
import java.awt.*;
import java.applet.*;


/** Esta clase es un Banner en el que aparecera texto desplazandose
  */
public class BannerParametros extends Applet implements Runnable{
   private String msg;
   private int tiempo;
   private int cx;
   private int cy;
   private String sentido;
   private Thread t = null;
   private boolean parado;
   
   /** Ocultamos el metodo init de Applet <br>
     * Se establecen los colores del fondo y de la fuente 
     * ademas del tipo de fuente
     */
   public void init(){
      setBackground(Color.blue);
      setForeground(Color.white);
      setFont(new Font("Arial",Font.BOLD,18));
   }
    
   /** Ocultamos el metodo start() de Applet <br>
     * Se obtienen los parametros, se crea un hilo y se lanza
     */
   public void start(){
      String parametro;
  
      // Obtencion de los parametros
  
      msg = getParameter("TEXTO");
      if (msg==null)
         msg = "Texto por defecto";
      
      msg = "     " + msg + "     ";

      sentido = getParameter("SENTIDO");
      if (sentido==null)
         sentido = "I";     
      
      parametro = getParameter("TIEMPO");
      try{
         if (parametro!=null)
            tiempo = Integer.parseInt(parametro);
         else
            tiempo = 250; // Por defecto
      }catch(NumberFormatException e){
         // Si se ha proporcionado el parametro pero no es un numero valido
         tiempo = 250; 
      }

      parametro = getParameter("CX");
      try{
         if (parametro!=null)
            cx = Integer.parseInt(parametro);
         else
            cx = 50; // Por defecto
      }catch(NumberFormatException e){
         // Si se ha proporcionado el parametro pero no es un numero valido
         cx = 50; 
      }
      
      parametro = getParameter("CY");
      try{
         if (parametro!=null)
            cy = Integer.parseInt(parametro);
         else
            cy = 30; // Por defecto
      }catch(NumberFormatException e){
         // Si se ha proporcionado el parametro pero no es un numero valido
         cy = 30; 
      }
       
      // Esto se puede hacer ya que esta clase implementa a Runnable
      t = new Thread(this);
      parado = false;
      t.start();
   }
   
   /** Implementamos el metodo run() ya que la clase Banner
     * implementa a la interfaz Runnable. <br>
     * En este metodo hay un bucle infinito deltro del cual
     * se repinta el applet, se duerme durante
     * 250 milisegundos, y el primer caracter se pone al final
     * de la cadena. <br>
     * Si se debe parar el hilo se sale del bucle.
     */
   public void run(){
      char ch;
      
      for ( ; ; ){
         try{
            repaint();
            Thread.sleep(tiempo);
            
            // En funcion de sentido desplazamos la frase a la
            // izquierda o a la derecha
            
            if (sentido.compareTo("I")==0){
               ch = msg.charAt(0);
               msg = msg.substring(1,msg.length());
               msg = msg + ch;
            }
            else{
               ch = msg.charAt(msg.length()-1);
               msg = msg.substring(0,msg.length()-1);
               msg = ch + msg;
            }
            
            if (parado)
               break;
         }catch(InterruptedException e){}
      }
   }
   
   /** Ocultamos el metodo stop() de Applet <br>
     * Si se debe parar el applet se pone el indicador a false
     * y se asigna la referencia al hilo a null.
     */
   public void stop(){
      parado = true;
      t = null;
   }
   
   /** Ocultamos el metodo paint(Graphics g) de Applet <br>
     * Se limita a pintar el mensage. Este metodo sera llamado
     * cuando se llame a repaint()
     */
   public void paint(Graphics g){
      g.drawString(msg,cx,cy);
   }
}
   
        
     