import java.io.*;
import java.security.*;
import javax.crypto.*;
import javax.crypto.spec.*;

/** Clase Cifra con un metodo de utilidad 
  */
public class Cifra{
   
   /** Metodo cifra.
     * @param in Origen de los datos a encriptar
     * @param out Fuente de los datos encriptados
     * @param codificador objeto del tipo Cipher que realiza el cifrado.
     */
   public static void cifra(InputStream in, OutputStream out,Cipher codificador) throws IOException, GeneralSecurityException{
   
      int tamEntrada = codificador.getBlockSize();
      byte[] entrada = new byte[tamEntrada];
   
      System.out.println("Tamao del bloque de entrada: " + tamEntrada);
      
   
      int tamSalida = codificador.getOutputSize(tamEntrada);
      byte[] salida = new byte[tamSalida];
   
      System.out.println("Tamao del bloque de salida: " + tamSalida);
   
      int numLeidos = 0;
      
      boolean finalizar = false;
      
      while (!finalizar){
      
         numLeidos = in.read(entrada);

         if (numLeidos == tamEntrada){
            int longitud = codificador.update(entrada,0,tamEntrada,salida);
            out.write(salida,0,longitud);
         }
         else
            finalizar = true;         
      }
      
      if (numLeidos>0)
         salida = codificador.doFinal(entrada,0,numLeidos);
      else
         salida = codificador.doFinal();
      
      out.write(salida);
      
   }
}