
import java.awt.*;
import java.io.*;
import java.lang.*;
import java.applet.*;

public class LeePropiedadesOcultas extends Applet {

   // Lista de propiedades a obtener
   private String[] propiedades ={"user.name","user.dir","user.home","java.home","java.class.path"};
   // Para almacenar el resultado
   private String[] cadenas;
   private boolean[] errores;


   public void init(){
      setFont(new Font("Arial",Font.BOLD,18));
      
      cadenas = new String[propiedades.length];
      errores = new boolean[propiedades.length];
      
      for (int i=0;i<propiedades.length;i++)      
         try {
            // Se intentan obtener las propiedades
            cadenas[i] = propiedades[i] + ": " + System.getProperty(propiedades[i]);
            errores[i] = false;
         }
         catch (SecurityException e) {
            // Si no se puede se muestra la propiedad que provoca el error
            cadenas[i] = "System.getProperty(" + propiedades[i] + "): ha provocado una excepcion de seguridad";
            errores[i] = true;
         }
   }

   public void paint(Graphics g) {
      int y = 25;
      // Mostramos el resultado
      for (int i=0;i<propiedades.length;i++){
         if (errores[i])
            g.setColor(Color.red);
         else
            g.setColor(Color.black);
         g.drawString(cadenas[i], 10, y);
         y = y + 25;
      }

  }
}

